设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 605|回复: 2

[教学] 点监视器应用(1)鼠标左右拖动实线、虚线矩形框

[复制链接]

签到天数: 1254 天

连续签到: 6 天

[LV.10]以坛为家III

点击这里给我发消息

已领礼包: 142个

财富等级: 日进斗金

发表于 2016-9-13 20:20:06 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
(一)同ACAD的表现形式,左侧拖动虚线、右侧拖动实线,不管WCS,UCS,矩形始终平行于屏幕。

点监视器XDRX_PointMonitor 应用(1)鼠标左右拖动实线、虚线矩形框

点监视器XDRX_PointMonitor 应用(1)鼠标左右拖动实线、虚线矩形框


  1. (defun c:tt (/ dynpt lastpnts pnts)
  2.   (defun _callback (dynpt / )
  3.     (setq pnts (xd::pnts:close (xd::geom:2pntrec p1 dynpt)))
  4.     (if (xd::pnt:islefttopbyline dynpt p1 pt1)
  5.       (setq mod 1)
  6.       (setq mod 0)
  7.     )
  8.     (if lastpnt
  9.       (xdrx_grdraw -2 mod lastpnts)
  10.     )
  11.     (if (/= lastmod mod)
  12.       (redraw)
  13.     )
  14.     (xdrx_grdraw -2 mod pnts)
  15.     (setq lastpnts pnts
  16.           lastpnt dynpt
  17.           lastmod mod
  18.     )
  19.   )
  20.   (if (setq p1 (getpoint "\nFirst Point<Quit>:"))
  21.     (progn
  22.             
  23.       (setq p1 (trans p1 1 0)
  24.             pt1 (mapcar
  25.                   '+
  26.                   p1
  27.                   (list 0.0 1.0 0)
  28.                 )
  29.       )
  30.       (xdrx_pointmonitor "_callback")
  31.       (xdrx_sysvar_push '("cursorsize" 2))
  32.       (if (setq p2 (getpoint "\nSecond Point<Quit>:"))
  33.         (progn
  34.         )
  35.       )
  36.       (xdrx_pointmonitor)
  37.       (xdrx_sysvar_pop)
  38.     )
  39.   )
  40.   (princ)
  41. )



(二) 鼠标拖动矩形,矩形平行于UCS的坐标轴的实线

点监视器XDRX_PointMonitor 应用(1)鼠标左右拖动实线、虚线矩形框

点监视器XDRX_PointMonitor 应用(1)鼠标左右拖动实线、虚线矩形框


  1. (defun c:tt (/ dynpt lastpnts pnts)
  2.   (defun _callback (dynpt / )
  3.     (setq pnts (xd::pnts:close (xd::geom:2pntrec p1 (trans dynpt 0 1))))
  4.     (if (xd::pnt:islefttopbyline dynpt (trans p1 1 0) (trans pt1 1 0))
  5.       (setq mod 1)
  6.       (setq mod 0)
  7.     )
  8.     (if lastpnt
  9.       (xdrx_grdraw -2 mod (xd::pnts:ucs2wcs lastpnts))
  10.     )
  11.     (if (/= lastmod mod)
  12.       (redraw)
  13.     )
  14.     (xdrx_grdraw -2 mod (xd::pnts:ucs2wcs pnts))
  15.     (setq lastpnts pnts
  16.           lastpnt dynpt
  17.           lastmod mod
  18.     )
  19.   )
  20.   (if (setq p1 (getpoint "\nFirst Point<Quit>:"))
  21.     (progn            
  22.       (setq pt1 (mapcar
  23.                   '+
  24.                   p1
  25.                   (list 0. 1.0 0.)
  26.                 )
  27.       )
  28.       (xdrx_pointmonitor "_callback")
  29.       (xdrx_sysvar_push '("cursorsize" 2))
  30.       (if (setq p2 (getpoint "\nSecond Point<Quit>:"))
  31.         (progn
  32.         )
  33.       )
  34.       (xdrx_pointmonitor)
  35.       (xdrx_sysvar_pop)
  36.     )
  37.   )
  38.   (princ)
  39. )





上一篇:XDRX API 没有2017适用的?
下一篇:批量多段线R角转C角
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复
百度谷歌雅虎搜狗搜搜有道360奇虎

使用道具 举报

签到天数: 674 天

连续签到: 1 天

[LV.9]以坛为家II

已领礼包: 18个

财富等级: 恭喜发财

发表于 2016-9-14 01:06:10 | 显示全部楼层
向老大学习~~
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 13 天

连续签到: 1 天

[LV.3]偶尔看看II

发表于 2017-12-18 16:58:38 | 显示全部楼层
简直太厉害了!学习中
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|Archiver|手机版|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

辽公网安备 21040202000005号

GMT+8, 2018-5-28 07:26 , Processed in 0.319081 second(s), 73 queries , Gzip On.

Powered by Discuz! X3.2

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表